## GtkApplicationWindow

GtkApplicationWindow — GtkWindow subclass with GtkApplication support

## Functions

GtkWidget * | gtk_application_window_new ()
void | gtk_application_window_set_show_menubar ()
gboolean | gtk_application_window_get_show_menubar ()
guint | gtk_application_window_get_id ()
void | gtk_application_window_set_help_overlay ()
GtkShortcutsWindow * | gtk_application_window_get_help_overlay ()

## Properties

gboolean | show-menubar | Read / Write / Construct

## Types and Values

struct | GtkApplicationWindow
struct | GtkApplicationWindowClass

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkWidget
                ╰── GtkContainer
                    ╰── GtkBin
                        ╰── GtkWindow
                            ╰── GtkApplicationWindow

## Implemented Interfaces

GtkApplicationWindow implements AtkImplementorIface, GtkBuildable, GActionGroup and GActionMap.

## Includes

    #include <gtk/gtk.h>

## Description

GtkApplicationWindow is a GtkWindow subclass that offers some extra functionality for better integration with GtkApplication features. Notably, it can handle both the application menu as well as the menubar. See `gtk_application_set_app_menu()` and `gtk_application_set_menubar()`.

This class implements the GActionGroup and GActionMap interfaces, to let you add window-specific actions that will be exported by the associated GtkApplication, together with its application-wide actions. Window-specific actions are prefixed with the “win.” prefix and application-wide actions are prefixed with the “app.” prefix. Actions must be addressed with the prefixed name when referring to them from a GMenuModel.

Note that widgets that are placed inside a GtkApplicationWindow can also activate these actions, if they implement the GtkActionable interface.

As with GtkApplication, the GDK lock will be acquired when processing actions arriving from other processes and should therefore be held when activating actions locally (if GDK threads are enabled).

The settings “gtk-shell-shows-app-menu” and “gtk-shell-shows-menubar” tell GTK+ whether the desktop environment is showing the application menu and menubar models outside the application as part of the desktop shell. For instance, on OS X, both menus will be displayed remotely; on Windows neither will be. gnome-shell (starting with version 3.4) will display the application menu, but not the menubar.

If the desktop environment does not display the menubar, then GtkApplicationWindow will automatically show a GtkMenuBar for it. This behaviour can be overridden with the “show-menubar” property. If the desktop environment does not display the application menu, then it will automatically be included in the menubar or in the windows client-side decorations.

#### A GtkApplicationWindow with a menubar

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21

    app = gtk_application_new ();

    builder = gtk_builder_new_from_string (
        "<interface>"
        "  <menu id='menubar'>"
        "    <submenu label='_Edit'>"
        "      <item label='_Copy' action='win.copy'/>"
        "      <item label='_Paste' action='win.paste'/>"
        "    </submenu>"
        "  </menu>"
        "</interface>",
        -1);

    menubar = G_MENU_MODEL (gtk_builder_get_object (builder,
                                                    "menubar"));
    gtk_application_set_menubar (G_APPLICATION (app), menubar);
    g_object_unref (builder);

    ...

    window = gtk_application_window_new (app);

#### Handling fallback yourself

A simple example

The XML format understood by GtkBuilder for GMenuModel consists of a toplevel `<menu>` element, which contains one or more `<item>` elements. Each `<item>` element contains `<attribute>` and `<link>` elements with a mandatory name attribute. `<link>` elements have the same content model as `<menu>`. Instead of `<link name="submenu>` or `<link name="section">`, you can use `<submenu>` or `<section>` elements.

Attribute values can be translated using gettext, like other GtkBuilder content. `<attribute>` elements can be marked for translation with a `translatable="yes"` attribute. It is also possible to specify message context and translator comments, using the context and comments attributes. To make use of this, the GtkBuilder must have been given the gettext domain to use.

The following attributes are used when constructing menu items:

- "label": a user-visible string to display

- "action": the prefixed name of the action to trigger

- "target": the parameter to use when activating the action

- "icon" and "verb-icon": names of icons that may be displayed

- "submenu-action": name of an action that may be used to determine if a submenu can be opened

- "hidden-when": a string used to determine when the item will be hidden. Possible values include "action-disabled", "action-missing", "macos-menubar".

The following attributes are used when constructing sections:

- "label": a user-visible string to use as section heading

- "display-hint": a string used to determine special formatting for the section. Possible values include "horizontal-buttons".

- "text-direction": a string used to determine the GtkTextDirection to use when "display-hint" is set to "horizontal-buttons". Possible values include "rtl", "ltr", and "none".

The following attributes are used when constructing submenus:

- "label": a user-visible string to display

- "icon": icon name to display

## Functions

### gtk_application_window_new ()

    GtkWidget *
    gtk_application_window_new (GtkApplication *application);

Creates a new GtkApplicationWindow.

#### Parameters

application | a GtkApplication |

#### Returns

a newly created GtkApplicationWindow

Since: 3.4

### gtk_application_window_set_show_menubar ()

    void
    gtk_application_window_set_show_menubar
                                   (GtkApplicationWindow *window,
                                    gboolean show_menubar);

Sets whether the window will display a menubar for the app menu and menubar as needed.

#### Parameters

window | a GtkApplicationWindow |
show_menubar | whether to show a menubar when needed |

Since: 3.4

### gtk_application_window_get_show_menubar ()

    gboolean
    gtk_application_window_get_show_menubar
                                   (GtkApplicationWindow *window);

Returns whether the window will display a menubar for the app menu and menubar as needed.

#### Parameters

window | a GtkApplicationWindow |

#### Returns

`TRUE` if `window` will display a menubar when needed

Since: 3.4

### gtk_application_window_get_id ()

    guint
    gtk_application_window_get_id (GtkApplicationWindow *window);

Returns the unique ID of the window. If the window has not yet been added to a GtkApplication, returns `0`.

#### Parameters

window | a GtkApplicationWindow |

#### Returns

the unique ID for `window` , or `0` if the window has not yet been added to a GtkApplication

Since: 3.6

### gtk_application_window_set_help_overlay ()

    void
    gtk_application_window_set_help_overlay
                                   (GtkApplicationWindow *window,
                                    GtkShortcutsWindow *help_overlay);

Associates a shortcuts window with the application window, and sets up an action with the name win.show-help-overlay to present it.

`window` takes resposibility for destroying `help_overlay` .

#### Parameters

window | a GtkApplicationWindow |
help_overlay | a GtkShortcutsWindow. | [nullable]

Since: 3.20

### gtk_application_window_get_help_overlay ()

    GtkShortcutsWindow *
    gtk_application_window_get_help_overlay
                                   (GtkApplicationWindow *window);

Gets the GtkShortcutsWindow that has been set up with a prior call to `gtk_application_window_set_help_overlay()`.

#### Parameters

window | a GtkApplicationWindow |

#### Returns

the help overlay associated with `window` , or `NULL`.

[transfer none][nullable]

Since: 3.20

## Types and Values

### struct GtkApplicationWindow

    struct GtkApplicationWindow;

### struct GtkApplicationWindowClass

    struct GtkApplicationWindowClass {
      GtkWindowClass parent_class;
    };

#### Members

## Property Details

### The `“show-menubar”` property

      “show-menubar”             gboolean

If this property is `TRUE`, the window will display a menubar that includes the app menu and menubar, unless these are shown by the desktop shell. See `gtk_application_set_app_menu()` and `gtk_application_set_menubar()`.

If `FALSE`, the window will not display a menubar, regardless of whether the desktop shell is showing the menus or not.

Flags: Read / Write / Construct

Default value: TRUE